<?php
/*
module:  CodCol - Coloration syntaxique - V 1.2

V 1.2: option couleur du syntax error
V 1.1: cration page d'option intgration panel/template
V 1.O: passage du script dans _codcol.txt
V 0.9: cration du module
Utilisation de la lib CodeMirror de Marijn Haverbeke
http://marijn.haverbeke.nl/codemirror/
Copyright Victor GAMBINO 2009 
Licence : CeCILL-B, http://www.cecill.info
*/


define ('FILE' , '<script src="js/colcod/js/codemirror.js" type="text/javascript"></script>
<?php 
if ($this->args[0]==\'source_editor\') {
    if ($this->args[1]==\'files_style\') {
        echo \'<script type="text/javascript">  var editor = CodeMirror.fromTextArea("source", {height: "550px",parserfile: "parsecss.js", stylesheet: "js/colcod/css/csscolors.css", path: "js/colcod/js/" });</script> \';
    } else {
        echo \' <script type="text/javascript"> var editor = CodeMirror.fromTextArea("source", {height: "550px",parserfile: ["parsexml.js", "parsecss.js", "tokenizejavascript.js", "parsejavascript.js",
                      "tokenizephp.js", "parsephp.js", "parsephphtmlmixed.js"],
            stylesheet: ["js/colcod/css/xmlcolors.css", "js/colcod/css/jscolors.css", "js/colcod/css/csscolors.css", "js/colcod/css/phpcolors.php"],
            path: "js/colcod/js/",  continuousScanning: 500 }); </script>\';
    }

}
?>');

define('BOT', '</body>');
define('INCFILE', "<?php include ('zdata/_codcol.txt') ?> </body> ");

define('WARN', "span.syntax-error {
  background-color: red;
}");
define('RED', "red");
define('YELLOW', "yellow");
define('NO', " ");

class Tcodcol extends Tmodule {

			
	function codcol_isOn(&$file, &$template, &$css) {

		$file = file_get_contents(self::$cms->cpath.'/_codcol.txt');
		$template = file_get_contents(self::$cms->ipath.'/'.self::$cms->config['files_template']);
		$css = file_get_contents(self::$cms->ipath.'/js/colcod/css/warncodcol.txt');
		return strpos($file, FILE) !== false;
		return strpos($template, FILE) !== false;
		return strpos($css, WARN) !== false;
		
	}
	
	function On()  {
		parent::On();
		if (!$this->codcol_isOn(&$file)) {
		file_put_contents(self::$cms->cpath.'/_codcol.txt', FILE ) ;
		file_put_contents(self::$cms->ipath.'/js/colcod/css/warncodcol.txt', WARN ) ;
		}
 
	}

	function Off() {
		parent::off();
//		$this->del_pnl();
		@unlink(self::$cms->cpath.'/_codcol.txt');
		@unlink(self::$cms->ipath.'/js/colcod/css/warncodcol.txt');
		$template = file_get_contents(self::$cms->ipath.'/'.self::$cms->config['files_template']);
		if (strpos($template,INCFILE )) {
			$template=str_replace(INCFILE,BOT,$template);
			file_put_contents(self::$cms->ipath.'/'.self::$cms->config['files_template'],$template);
		}
	}
  
	function reset() {
	$this->Off();
	$this->On();
	}
	
	function pnl() {
	$this->reset();
	$max = count(self::$cms->struct);
	$np = $max+1;
	$p = (int)self::$cms->args[2];
		if ($p>0 && $p<=$max) {
		$dta = & self::$cms->struct[$p];
		}
	$rang = $dta[cPageRang]+1;
	self::$cms->struct[$np] = array('_codcol', 'CoDCoL', $dta[cPageRang]+1, 4098, 0, array(),array());
	self::$cms->struct[$np][cPageOpt] = 128;         
	self::$cms->writeStruct(true);
	}
	
	function del_pnl(){

	}
	
  
	function tmpl() {
	$this->reset();
    $template = file_get_contents(self::$cms->ipath.'/'.self::$cms->config['files_template']);
		if (strpos($template,BOT )) {
		$template=str_replace(BOT,INCFILE,$template);
		file_put_contents(self::$cms->ipath.'/'.self::$cms->config['files_template'],$template);
		}
	}
	
	function warn_reset() {
			@unlink(self::$cms->ipath.'/js/colcod/css/warncodcol.txt');
			file_put_contents(self::$cms->ipath.'/js/colcod/css/warncodcol.txt', WARN ) ;
	}
	
	function warn_y() {
		$this->warn_reset();
		$css = file_get_contents(self::$cms->ipath.'/js/colcod/css/warncodcol.txt');
		if (strpos($css,RED )) {
			$css=str_replace(RED,YELLOW,$css);
			file_put_contents(self::$cms->ipath.'/js/colcod/css/warncodcol.txt', $css);
			}
	}

	function warn_no() {
		$this->warn_reset();
		$css = file_get_contents(self::$cms->ipath.'/js/colcod/css/warncodcol.txt');
		if (strpos($css,RED )) {
			$css=str_replace(RED,NO,$css);
			file_put_contents(self::$cms->ipath.'/js/colcod/css/warncodcol.txt', $css);
			}
	}	
	
	function dojob() {
			 parent::dojob();
			 
			if ($_POST['rec']=='enregistre') {
			switch($_POST['reccodcol']) {
			  case 'panneau' :
					($this->pnl()!=0)?self::$cms->msgShow('done_failed'):self::$cms->msgShow('done_ok');
			    break;
				case 'template':
					($this->tmpl()!=0)?self::$cms->msgShow('done_failed'):self::$cms->msgShow('done_ok');
			    break;
				default :
				  self::$cms->msgShow($this->get_message('nochoice'),false);
			}
			}
			if ($_POST['reccolor']=='colorenregistre') {
			switch($_POST['colorcodcol']) {
			  	case 'rouge' :
					($this->warn_reset()!=0)?self::$cms->msgShow('done_failed'):self::$cms->msgShow('done_ok');
			    break;
				case 'jaune':
					($this->warn_y()!=0)?self::$cms->msgShow('done_failed'):self::$cms->msgShow('done_ok');
			    break;
				case 'aucune':
					($this->warn_no()!=0)?self::$cms->msgShow('done_failed'):self::$cms->msgShow('done_ok');
			    break;
				default :
				  self::$cms->msgShow($this->get_message('nochoice'),false);
			}
			}
	
			if ($_POST['reset']=='reinitialiser') {
			$this->reset();			
			}

	
  
	$reccodcol = empty($_POST['reccodcol'])?'template':$_POST['reccodcol'];
	$colorcodcol = empty($_POST['colorcodcol'])?'jaune':$_POST['colorcodcol'];
	$out = '<form method="post" action="'.self::$cms->base.'codcol" enctype="multipart/form-data">';
	$out .= '<table class="ztable">';
	$out .= '<tr><td colspan="2"><center><h1>Configuration de CoDCoL</h1></center></td></tr>';
	count(self::$cms->struct);
	$out .= '</table>';
	$out .= '<table class="ztable"><tr><td colspan="2"><center><strong>Mode d\'utilisation de CoDCoL</strong></center></td></tr>';
	$out .= '<tr><td><input name="reccodcol" type="radio" value="panneau" '.($reccodcol=='panneau'?'checked':'').' > dans un panneau</td></tr>';
	$out .= '<tr><td><input name="reccodcol" type="radio" value="template"' .($reccodcol=='template'?'checked':'').' > intgr dans le template</td></tr>';
		$out .= '<tr><td colspan="2"><input type="submit" name="Submit" value="'.self::$cms->get_message('submit').'" /><input name="rec" type="hidden" value="enregistre" /></td></tr></table></form>';

	$out .= '<form method="post" action="'.self::$cms->base.'codcol" enctype="multipart/form-data">';
	$out .= '<table class="ztable"><tr><td colspan="2"><center><strong>Gestion de la couleur des syntax errors de CoDCoL</strong></center></td></tr>';
	$out .= '<tr><td><input name="colorcodcol" type="radio" value="rouge" '.($colorcodcol=='rouge'?'checked':'').' > rouge</td></tr>';
	$out .= '<tr><td><input name="colorcodcol" type="radio" value="jaune"' .($colorcodcol=='jaune'?'checked':'').' > jaune</td></tr>';
	$out .= '<tr><td><input name="colorcodcol" type="radio" value="aucune"' .($colorcodcol=='aucune'?'checked':'').' > aucune</td></tr>';
	$out .= '<tr><td colspan="2"><input type="submit" name="Submit" value="'.self::$cms->get_message('submit').'" /><input name="reccolor" type="hidden" value="colorenregistre" /></td></tr></table></form>';
	
	$out .= '<form method="post" action="'.self::$cms->base.'codcol" enctype="multipart/form-data">';
	$out .= '<input type="submit" name="Submit" value="Rinitialiser CoDCoL"/><input name="reset" type="hidden" value="reinitialiser" /></form>';
	
	return $out;
}
  } 
?>